package models

import (
	"fmt"

	u "gocommunity.ru/workshop/internal/utils"
)


type ServiceVehicle struct {
	ServiceId   int32 `json:"service_id"`
	VehicleId  int32 `json:"vehicle_id"`
}

func (vehicle *ServiceVehicle) Validate() (map[string]interface{}, bool) {

	if vehicle.ServiceId <= 0 {
		return u.Message(false, "ServiceId can't be < 0!"), false
	}

	if vehicle.VehicleId <= 0 {
		return u.Message(false, "VehicleId can't be < 0!"), false
	}

	return u.Message(true, "success"), true
}

func (serviceVehicle *ServiceVehicle) AcceptVehicle() map[string]interface{} {

	if response, ok := serviceVehicle.Validate(); !ok {
		return response
	}
	
	err := GetDB().Table("service_vehicle").Create(serviceVehicle).Error
	if err != nil {
		fmt.Println(err)
		return nil
	}

	resp := u.Message(true, "success")
	resp["serviceVehicle"] = serviceVehicle
	return resp
}